/* GCC */

#include <iostream>
#include <fstream>
#include <vector>
#include <cmath>

using namespace std;

ifstream fin("aliens.in");
ofstream fout("aliens.out");

const int inf=100000000;
int n, m, k;
string letters="abcdefghijklmnop";
vector< vector<int> > nums;
vector< vector<int> > p;
int currSize;

int calcSize(vector<int> a){
    int sum=0;
    for(int i=0; i<a.size(); i++) sum+=p[i][a[i]];
    return sum;
}

void fileOut(vector<int> a){
    for(int i=0; i<a.size(); i++){
        fout<<letters[a[i]];
    }
    fout<<endl;
}

void show(vector<int> a){
    for(int i=0; i<a.size(); i++){
        cout<<a[i]<<' ';
    }
    cout<<endl;
}

bool check(vector<int> a){
    for(int i=0; i<nums.size(); i++){
        if(nums[i]==a) return true;
    }
    return false;
}

vector<int> getNewWord(vector<int> vec){
    int place, newNum;
    int min=inf;
    int i, z, j;
    for(i=0; i<m; i++){ //each letter
        for(z=0; z<n; z++){ //each position
            if(p[i][z]==p[i][vec[i]]) continue;
            int dif=p[i][z]-p[i][vec[i]];
            vector<int> helper=vec;
            helper[i]=z;
            if(dif<min && !check(helper) && dif>0){
                min=dif;
                place=i;
                newNum=z;
            }
        }
    }
    vec[place]=newNum;
    return vec;
}

void getNext(){
    int min=inf;
    vector<int> tobuild;
    for(int i=0; i<nums.size(); i++){
        vector<int> newvec=getNewWord(nums[i]);
        int hissize=calcSize(newvec);
        if(hissize<min){
            min=hissize;
            tobuild=newvec;
        }
    }
    nums.push_back(tobuild);
}

int main(){
    
    fin>>n>>m>>k;
    int i, z, j, minCurr, maxCurr, minWord=0, maxWord=0;
    p=vector< vector<int> >(m, vector<int>(n));
    
    //reading file and finding minWord, maxWord
    nums.push_back(vector<int>(m));
    for(i=0; i<m; i++){
        int minNum;
        minCurr=inf;
        for(j=0; j<n; j++){
            fin>>p[i][j];
            if(p[i][j]<minCurr) {
                minCurr=p[i][j];
                minNum=j;
            }
        }
        nums[0][i]=minNum;
        minWord+=minCurr;
        maxWord+=maxCurr;
    }
    
    
    while(nums.size()<k){
        getNext();
        show(nums[nums.size()-1]);
    }
    
    fileOut(nums[k-1]);
    
    
    fin.close();
    fout.close();
    return 0;
}
