/* GCC */

#include <cstdio>
#include <vector>
#include <string>
#include <iostream>
#include <algorithm>
using namespace std;

int n, m, k;
int limit;
int price[20][20];
bool GenPrefix = false;

vector<pair<int, int> > suffixes;

vector<string> prefixes;
vector<int> pref_costs;
vector<string> strs;

string a;

bool my_cmp(pair<int, int> l, pair<int, int> r)
{
    if (l.first > r.first)
        return true;
    if (l.first == r.first && strs[l.second] < strs[r.second])
        return true;
    return false;
}

bool my_cmp2(pair<int, int> l, int r)
{
    if (l.first < r)
        return true;
    return false;
}

void backtrack(int i)
{
    if (i == limit) {
        int offset = ((!GenPrefix)?(m - limit):0);
        int sum = 0;
        for (int j = 0; j < limit; ++j)
            sum += price[j+offset][a[j]];
        if (!GenPrefix) {
            suffixes.push_back(make_pair(sum, strs.size()));
            strs.push_back(a);
        } else {
            prefixes.push_back(a);
            pref_costs.push_back(sum);
        }
        return;
    }
    for (int j = 0; j < n; ++j) {
        a[i] = j;
        backtrack(i+1);
    }
}

int h(int x)
{
    return lower_bound(suffixes.begin(), suffixes.end(), x, my_cmp2) - suffixes.begin();
}

int f(int x)
{
    int kount = 0;
    for (int i = 0; i < prefixes.size(); ++i) {
        int c = pref_costs[i];
        kount += h(x-c);
    }
    return kount;
}

int g(const string& str, int x)
{
    int kount =0;

    if (str.size() <= limit) {
        for (int i =0;i< prefixes.size(); ++i) {
            bool ok = true;
            for (int j =0;j<str.size();++j) {
                if (str[j] != prefixes[i][j]){
                    ok = false;
                    break;
                }
            }
            if (!ok)
                continue;

            kount += (h(x-pref_costs[i]+1) - h(x-pref_costs[i]));
        }
    } else {
        int n = str.size()-limit;
        string pr = str.substr(0, limit);
        cerr <<  "pr ="<<pr.size() << "\n";
        for (int i=0;i<suffixes.size(); ++i) {
            bool ok = true;
            const string& s = strs[suffixes[i].second];
            int c = suffixes[i].first;

            for (int j =0;j<n;++j) {
                if (str[j+limit] != s[j]){
                    ok = false;
                    break;
                }
            }
            if (!ok)
                continue;
            kount += g(pr, x);
        }
    }
    return kount;
}

int main()
{
    freopen("aliens.in", "r", stdin);
    freopen("aliens.out", "w", stdout);

    scanf("%d%d%d", &n, &m, &k);
    for (int i=0;i<m;++i)
        for (int j=0;j<n;++j)
            scanf("%d", &price[i][j]);

    if (1) {
        a.resize(m);
        limit = m;
        backtrack(0);
        sort(suffixes.begin(), suffixes.end(), my_cmp);

        for (int i = 0; i < m; ++i) {
            printf("%c", strs[suffixes[k-1].second][i]+'a');
        }
        printf("\n");
        return 0;
    }

    a.resize(m/2);
    limit = m/2;

    backtrack(0);
    sort(suffixes.begin(), suffixes.end());

    GenPrefix= true;
    limit = m - m/2;
    a.resize(limit);
    backtrack(0);
    for (int i =0;i<prefixes.size(); ++i)
    {
        for (int j =0;j< limit;++j)
            cerr << (char)(prefixes[i][j]+'a');
        cerr << ": " << pref_costs[i] << "\n";
    }
    cerr << "\n\nsuff:\n";
    for (int i =0;i<suffixes.size(); ++i)
    {
        for (int j =0;j< limit;++j)
            cerr << (char)(strs[suffixes[i].second][j]+'a');
        cerr << ": " << suffixes[i].first << "\n";
    }


    for (int i =0;i<10; ++i)
        cerr << i << ": " <<f(i) << "\n";

    string test;
    test.push_back(0);
    test.push_back(1);
    test.push_back(1);
    test.push_back(1);

    cerr << g(test, 6) << endl;

    return 0;
}
